/* playlist-file.c generated by valac 0.56.16, the Vala compiler
 * generated from playlist-file.vala, do not modify */

#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

#define G4_PLAY_LIST_TYPE_NONE ((guint) 0)
#define G4_PLAY_LIST_TYPE_M3U ((guint) 1)
#define G4_PLAY_LIST_TYPE_PLS ((guint) 2)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

VALA_EXTERN guint g4_get_playlist_type (const gchar* mimetype);
VALA_EXTERN gboolean g4_is_playlist_file (const gchar* mimetype);
VALA_EXTERN gboolean g4_is_valid_uri (const gchar* uri,
                          GUriFlags flags);
VALA_EXTERN gchar* g4_load_playlist_file (GFile* file,
                              GPtrArray* uris);
VALA_EXTERN gchar* g4_load_m3u_file (GFile* file,
                         GPtrArray* uris,
                         GError** error);
VALA_EXTERN gchar* g4_load_pls_file (GFile* file,
                         GPtrArray* uris,
                         GError** error);
VALA_EXTERN gchar* g4_parse_relative_uri (const gchar* uri,
                              GFile* parent);
VALA_EXTERN gchar* g4_get_file_display_name (GFile* file);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

guint
g4_get_playlist_type (const gchar* mimetype)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
	static GQuark _tmp1_label0 = 0;
	static GQuark _tmp1_label1 = 0;
	guint result;
	g_return_val_if_fail (mimetype != NULL, 0U);
	_tmp0_ = mimetype;
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("audio/x-mpegurl")))) {
		switch (0) {
			default:
			{
				result = G4_PLAY_LIST_TYPE_M3U;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("audio/x-scpls")))) {
		switch (0) {
			default:
			{
				result = G4_PLAY_LIST_TYPE_PLS;
				return result;
			}
		}
	} else {
		switch (0) {
			default:
			{
				result = G4_PLAY_LIST_TYPE_NONE;
				return result;
			}
		}
	}
}

gboolean
g4_is_playlist_file (const gchar* mimetype)
{
	gboolean result;
	g_return_val_if_fail (mimetype != NULL, FALSE);
	result = g4_get_playlist_type (mimetype) != G4_PLAY_LIST_TYPE_NONE;
	return result;
}

gboolean
g4_is_valid_uri (const gchar* uri,
                 GUriFlags flags)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
	g_return_val_if_fail (uri != NULL, FALSE);
	{
		gboolean _tmp0_ = FALSE;
		_tmp0_ = g_uri_is_valid (uri, flags, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		result = _tmp0_;
		return result;
	}
	goto __finally0;
	__catch0_g_error:
	{
		g_clear_error (&_inner_error0_);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp1_ = FALSE;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp1_;
	}
	result = FALSE;
	return result;
}

gchar*
g4_load_playlist_file (GFile* file,
                       GPtrArray* uris)
{
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (file != NULL, NULL);
	g_return_val_if_fail (uris != NULL, NULL);
	{
		GFileInfo* info = NULL;
		GFileInfo* _tmp0_;
		const gchar* _tmp1_ = NULL;
		GFileInfo* _tmp2_;
		const gchar* _tmp3_;
		guint type = 0U;
		_tmp0_ = g_file_query_info (file, G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
		info = _tmp0_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp2_ = info;
		_tmp3_ = g_file_info_get_content_type (_tmp2_);
		_tmp1_ = _tmp3_;
		if (_tmp1_ == NULL) {
			_tmp1_ = "";
		}
		type = g4_get_playlist_type ((const gchar*) _tmp1_);
		switch (type) {
			case G4_PLAY_LIST_TYPE_M3U:
			{
				gchar* _tmp4_ = NULL;
				gchar* _tmp5_;
				gchar* _tmp6_;
				_tmp5_ = g4_load_m3u_file (file, uris, &_inner_error0_);
				_tmp4_ = _tmp5_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					_g_object_unref0 (info);
					goto __catch0_g_error;
				}
				_tmp6_ = _tmp4_;
				_tmp4_ = NULL;
				result = _tmp6_;
				_g_free0 (_tmp4_);
				_g_object_unref0 (info);
				return result;
			}
			case G4_PLAY_LIST_TYPE_PLS:
			{
				gchar* _tmp7_ = NULL;
				gchar* _tmp8_;
				gchar* _tmp9_;
				_tmp8_ = g4_load_pls_file (file, uris, &_inner_error0_);
				_tmp7_ = _tmp8_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					_g_object_unref0 (info);
					goto __catch0_g_error;
				}
				_tmp9_ = _tmp7_;
				_tmp7_ = NULL;
				result = _tmp9_;
				_g_free0 (_tmp7_);
				_g_object_unref0 (info);
				return result;
			}
			default:
			break;
		}
		_g_object_unref0 (info);
	}
	goto __finally0;
	__catch0_g_error:
	{
		g_clear_error (&_inner_error0_);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	result = NULL;
	return result;
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = ((gchar*) self)[index];
	result = _tmp0_;
	return result;
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		g_clear_error (&_inner_error0_);
		g_assert_not_reached ();
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

gchar*
g4_load_m3u_file (GFile* file,
                  GPtrArray* uris,
                  GError** error)
{
	GFileInputStream* fis = NULL;
	GFileInputStream* _tmp0_;
	GBufferedInputStream* bis = NULL;
	GFileInputStream* _tmp1_;
	GBufferedInputStream* _tmp2_;
	GDataInputStream* dis = NULL;
	GBufferedInputStream* _tmp3_;
	GDataInputStream* _tmp4_;
	GFile* parent = NULL;
	GFile* _tmp5_;
	gsize length = 0UL;
	gchar* str = NULL;
	gchar* _tmp25_;
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (file != NULL, NULL);
	g_return_val_if_fail (uris != NULL, NULL);
	_tmp0_ = g_file_read (file, NULL, &_inner_error0_);
	fis = _tmp0_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		return NULL;
	}
	_tmp1_ = fis;
	_tmp2_ = (GBufferedInputStream*) g_buffered_input_stream_new ((GInputStream*) _tmp1_);
	bis = _tmp2_;
	_tmp3_ = bis;
	_tmp4_ = g_data_input_stream_new ((GInputStream*) _tmp3_);
	dis = _tmp4_;
	_tmp5_ = g_file_get_parent (file);
	parent = _tmp5_;
	length = (gsize) 0;
	str = NULL;
	while (TRUE) {
		gchar* _tmp6_ = NULL;
		GDataInputStream* _tmp7_;
		gsize _tmp8_ = 0UL;
		gchar* _tmp9_;
		gchar* _tmp10_;
		const gchar* _tmp11_;
		gchar* uri = NULL;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gboolean _tmp14_ = FALSE;
		_tmp7_ = dis;
		_tmp9_ = g_data_input_stream_read_line_utf8 (_tmp7_, &_tmp8_, NULL, &_inner_error0_);
		length = _tmp8_;
		_tmp6_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (str);
			_g_object_unref0 (parent);
			_g_object_unref0 (dis);
			_g_object_unref0 (bis);
			_g_object_unref0 (fis);
			return NULL;
		}
		_tmp10_ = _tmp6_;
		_tmp6_ = NULL;
		_g_free0 (str);
		str = _tmp10_;
		_tmp11_ = str;
		if (!(_tmp11_ != NULL)) {
			_g_free0 (_tmp6_);
			break;
		}
		_tmp12_ = str;
		_tmp13_ = g_strdup ((const gchar*) _tmp12_);
		uri = _tmp13_;
		if (length > ((gsize) 0)) {
			const gchar* _tmp15_;
			_tmp15_ = uri;
			_tmp14_ = string_get (_tmp15_, (glong) 0) != '#';
		} else {
			_tmp14_ = FALSE;
		}
		if (_tmp14_) {
			gchar* abs_uri = NULL;
			const gchar* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			GFile* _tmp19_;
			gchar* _tmp20_;
			gchar* _tmp21_;
			const gchar* _tmp22_;
			_tmp16_ = uri;
			_tmp17_ = string_replace (_tmp16_, "\r", "");
			_tmp18_ = _tmp17_;
			_tmp19_ = parent;
			_tmp20_ = g4_parse_relative_uri (_tmp18_, _tmp19_);
			_tmp21_ = _tmp20_;
			_g_free0 (_tmp18_);
			abs_uri = _tmp21_;
			_tmp22_ = abs_uri;
			if (_tmp22_ != NULL) {
				const gchar* _tmp23_;
				gchar* _tmp24_;
				_tmp23_ = abs_uri;
				_tmp24_ = g_strdup ((const gchar*) _tmp23_);
				g_ptr_array_add (uris, _tmp24_);
			}
			_g_free0 (abs_uri);
		}
		_g_free0 (uri);
		_g_free0 (_tmp6_);
	}
	_tmp25_ = g4_get_file_display_name (file);
	result = _tmp25_;
	_g_free0 (str);
	_g_object_unref0 (parent);
	_g_object_unref0 (dis);
	_g_object_unref0 (bis);
	_g_object_unref0 (fis);
	return result;
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	g_strstrip (_result_);
	result = _result_;
	return result;
}

static gint
string_index_of_char (const gchar* self,
                      gunichar c,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = g_utf8_strchr (((gchar*) self) + start_index, (gssize) -1, c);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	if (_tmp1_ != NULL) {
		gchar* _tmp2_;
		_tmp2_ = _result_;
		result = (gint) (_tmp2_ - ((gchar*) self));
		return result;
	} else {
		result = -1;
		return result;
	}
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
	end = _tmp0_;
	_tmp1_ = end;
	if (_tmp1_ == NULL) {
		result = maxlen;
		return result;
	} else {
		gchar* _tmp2_;
		_tmp2_ = end;
		result = (glong) (_tmp2_ - str);
		return result;
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	if (offset >= ((glong) 0)) {
		_tmp0_ = len >= ((glong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		string_length = string_strnlen ((gchar*) self, offset + len);
	} else {
		gint _tmp1_;
		gint _tmp2_;
		_tmp1_ = strlen (self);
		_tmp2_ = _tmp1_;
		string_length = (glong) _tmp2_;
	}
	if (offset < ((glong) 0)) {
		offset = string_length + offset;
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
	} else {
		g_return_val_if_fail (offset <= string_length, NULL);
	}
	if (len < ((glong) 0)) {
		len = string_length - offset;
	}
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
	result = _tmp3_;
	return result;
}

gchar*
g4_load_pls_file (GFile* file,
                  GPtrArray* uris,
                  GError** error)
{
	gchar* name = NULL;
	gchar* _tmp0_;
	GFileInputStream* fis = NULL;
	GFileInputStream* _tmp1_;
	GBufferedInputStream* bis = NULL;
	GFileInputStream* _tmp2_;
	GBufferedInputStream* _tmp3_;
	GDataInputStream* dis = NULL;
	GBufferedInputStream* _tmp4_;
	GDataInputStream* _tmp5_;
	GFile* parent = NULL;
	GFile* _tmp6_;
	gboolean list_found = FALSE;
	gsize length = 0UL;
	gint pos = 0;
	gchar* str = NULL;
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (file != NULL, NULL);
	g_return_val_if_fail (uris != NULL, NULL);
	_tmp0_ = g4_get_file_display_name (file);
	name = _tmp0_;
	_tmp1_ = g_file_read (file, NULL, &_inner_error0_);
	fis = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_free0 (name);
		return NULL;
	}
	_tmp2_ = fis;
	_tmp3_ = (GBufferedInputStream*) g_buffered_input_stream_new ((GInputStream*) _tmp2_);
	bis = _tmp3_;
	_tmp4_ = bis;
	_tmp5_ = g_data_input_stream_new ((GInputStream*) _tmp4_);
	dis = _tmp5_;
	_tmp6_ = g_file_get_parent (file);
	parent = _tmp6_;
	list_found = FALSE;
	length = (gsize) 0;
	pos = -1;
	str = NULL;
	while (TRUE) {
		gchar* _tmp7_ = NULL;
		GDataInputStream* _tmp8_;
		gsize _tmp9_ = 0UL;
		gchar* _tmp10_;
		gchar* _tmp11_;
		const gchar* _tmp12_;
		gchar* line = NULL;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gboolean _tmp15_ = FALSE;
		const gchar* _tmp16_;
		gint _tmp17_;
		gint _tmp18_;
		_tmp8_ = dis;
		_tmp10_ = g_data_input_stream_read_line_utf8 (_tmp8_, &_tmp9_, NULL, &_inner_error0_);
		length = _tmp9_;
		_tmp7_ = _tmp10_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (str);
			_g_object_unref0 (parent);
			_g_object_unref0 (dis);
			_g_object_unref0 (bis);
			_g_object_unref0 (fis);
			_g_free0 (name);
			return NULL;
		}
		_tmp11_ = _tmp7_;
		_tmp7_ = NULL;
		_g_free0 (str);
		str = _tmp11_;
		_tmp12_ = str;
		if (!(_tmp12_ != NULL)) {
			_g_free0 (_tmp7_);
			break;
		}
		_tmp13_ = str;
		_tmp14_ = string_strip ((const gchar*) _tmp13_);
		line = _tmp14_;
		_tmp16_ = line;
		_tmp17_ = strlen (_tmp16_);
		_tmp18_ = _tmp17_;
		if (_tmp18_ > 1) {
			const gchar* _tmp19_;
			_tmp19_ = line;
			_tmp15_ = string_get (_tmp19_, (glong) 0) == '[';
		} else {
			_tmp15_ = FALSE;
		}
		if (_tmp15_) {
			GCompareFunc _tmp20_;
			const gchar* _tmp21_;
			_tmp20_ = ((GCompareFunc) g_strcmp0);
			_tmp21_ = line;
			list_found = _tmp20_ (_tmp21_, "[playlist]") == 0;
		} else {
			gboolean _tmp22_ = FALSE;
			if (list_found) {
				const gchar* _tmp23_;
				_tmp23_ = line;
				pos = string_index_of_char (_tmp23_, (gunichar) '=', 0);
				_tmp22_ = pos > 0;
			} else {
				_tmp22_ = FALSE;
			}
			if (_tmp22_) {
				const gchar* _tmp24_;
				_tmp24_ = line;
				if (g_str_has_prefix (_tmp24_, "File")) {
					gchar* uri = NULL;
					const gchar* _tmp25_;
					gchar* _tmp26_;
					gchar* _tmp27_;
					gchar* _tmp28_;
					gchar* _tmp29_;
					gchar* abs_uri = NULL;
					const gchar* _tmp30_;
					GFile* _tmp31_;
					gchar* _tmp32_;
					const gchar* _tmp33_;
					_tmp25_ = line;
					_tmp26_ = string_substring (_tmp25_, (glong) (pos + 1), (glong) -1);
					_tmp27_ = _tmp26_;
					_tmp28_ = string_strip (_tmp27_);
					_tmp29_ = _tmp28_;
					_g_free0 (_tmp27_);
					uri = _tmp29_;
					_tmp30_ = uri;
					_tmp31_ = parent;
					_tmp32_ = g4_parse_relative_uri (_tmp30_, _tmp31_);
					abs_uri = _tmp32_;
					_tmp33_ = abs_uri;
					if (_tmp33_ != NULL) {
						const gchar* _tmp34_;
						gchar* _tmp35_;
						_tmp34_ = abs_uri;
						_tmp35_ = g_strdup ((const gchar*) _tmp34_);
						g_ptr_array_add (uris, _tmp35_);
					}
					_g_free0 (abs_uri);
					_g_free0 (uri);
				} else {
					const gchar* _tmp36_;
					_tmp36_ = line;
					if (g_ascii_strncasecmp (_tmp36_, "X-GNOME-Title", (gsize) pos) == 0) {
						gchar* title = NULL;
						const gchar* _tmp37_;
						gchar* _tmp38_;
						gchar* _tmp39_;
						gchar* _tmp40_;
						gchar* _tmp41_;
						const gchar* _tmp42_;
						gint _tmp43_;
						gint _tmp44_;
						_tmp37_ = line;
						_tmp38_ = string_substring (_tmp37_, (glong) (pos + 1), (glong) -1);
						_tmp39_ = _tmp38_;
						_tmp40_ = string_strip (_tmp39_);
						_tmp41_ = _tmp40_;
						_g_free0 (_tmp39_);
						title = _tmp41_;
						_tmp42_ = title;
						_tmp43_ = strlen (_tmp42_);
						_tmp44_ = _tmp43_;
						if (_tmp44_ > 0) {
							const gchar* _tmp45_;
							gchar* _tmp46_;
							_tmp45_ = title;
							_tmp46_ = g_strdup (_tmp45_);
							_g_free0 (name);
							name = _tmp46_;
						}
						_g_free0 (title);
					}
				}
			}
		}
		_g_free0 (line);
		_g_free0 (_tmp7_);
	}
	result = name;
	_g_free0 (str);
	_g_object_unref0 (parent);
	_g_object_unref0 (dis);
	_g_object_unref0 (bis);
	_g_object_unref0 (fis);
	return result;
}

gchar*
g4_parse_relative_uri (const gchar* uri,
                       GFile* parent)
{
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gint _tmp2_;
	GFile* _tmp9_ = NULL;
	GFile* _tmp10_ = NULL;
	GFile* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	gchar* _tmp15_;
	gchar* result;
	g_return_val_if_fail (uri != NULL, NULL);
	_tmp1_ = strlen (uri);
	_tmp2_ = _tmp1_;
	if (_tmp2_ > 0) {
		_tmp0_ = string_get (uri, (glong) 0) == '/';
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GFile* _tmp3_;
		GFile* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp3_ = g_file_new_for_path (uri);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_file_get_uri (_tmp4_);
		_tmp6_ = _tmp5_;
		_g_object_unref0 (_tmp4_);
		result = _tmp6_;
		return result;
	} else {
		if (g4_is_valid_uri (uri, G_URI_FLAGS_NONE)) {
			const gchar* _tmp7_ = NULL;
			gchar* _tmp8_;
			if (g_str_has_prefix (uri, "file://")) {
				_tmp7_ = (const gchar*) uri;
			} else {
				_tmp7_ = NULL;
			}
			_tmp8_ = g_strdup (_tmp7_);
			result = _tmp8_;
			return result;
		}
	}
	_tmp9_ = parent;
	_tmp10_ = NULL;
	if (_tmp9_ != NULL) {
		GFile* _tmp11_;
		_tmp11_ = g_file_resolve_relative_path (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, g_file_get_type (), GFile), uri);
		_g_object_unref0 (_tmp10_);
		_tmp10_ = _tmp11_;
	}
	_tmp12_ = _tmp10_;
	_tmp13_ = NULL;
	if (_tmp12_ != NULL) {
		gchar* _tmp14_;
		_tmp14_ = g_file_get_uri (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, g_file_get_type (), GFile));
		_g_free0 (_tmp13_);
		_tmp13_ = _tmp14_;
	}
	_tmp15_ = _tmp13_;
	_tmp13_ = NULL;
	result = _tmp15_;
	_g_free0 (_tmp13_);
	_g_object_unref0 (_tmp10_);
	return result;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

